-- Name: FreeSlots
-- Verson: 1.0.5
-- Author: Specko
-- Description: Displays free inventory slots without opening the bag screen.
-- ToDo:
--  Add Currency
--  Add Alliance Points

local wm = GetWindowManager()
local em = GetEventManager()
local print = d


FreeSlots = {}
FreeSlots.name = "FreeSlots"
FreeSlots.version	= "v2.0.1"
FreeSlots.settingsVersion = 1;

FreeSlots.settingsDefaults = {
	wm = {
		x = 30;
		y = 1035;
		width = 180;
		height = 100;
	}
}


function FreeSlots.Initialize( eventCode, addOnName )


	if ( addOnName ~= FreeSlots.name ) then
		return
	end

	FreeSlots.settings = ZO_SavedVars:New( "FreeSlotsSettings" , FreeSlots.settingsVersion, nil, FreeSlots.settingsDefaults, nil );

	FreeSlotsUI:SetAnchor( TOPLEFT, GuiRoot, TOPLEFT, FreeSlots.settings.wm.x, FreeSlots.settings.wm.y );
	FreeSlotsUI:SetWidth( FreeSlots.settings.wm.width );
	FreeSlotsUI:SetHeight( FreeSlots.settings.wm.height );

end

EVENT_MANAGER:RegisterForEvent( "FreeSlots" , EVENT_ADD_ON_LOADED , FreeSlots.Initialize )

function getAlliancePointsToDisplay()

	ap = 0;

	ap = GetAlliancePoints();

	FreeSlotsUIAlliancePointsDisplay:SetText(string.format(ap));

	return ap;
end

function getGoldToDisplay()

	gold = 0;

	gold = GetCurrentMoney();

	FreeSlotsUICurrentGoldDisplay:SetText(string.format(gold));

	return gold
end

function getBankSpaceToDisplay()

	bankSpace = 0;

	bankSpace = GetNumBagFreeSlots(BAG_BANK);

	FreeSlotsUIBankSlotsDisplay:SetText(string.format(bankSpace));

	return bankSpace
end


function ShowFreeSlots()

	red = 0;
	green = 0;
	blue = 0;
	alpha = 255;
	defaultColor = FreeSlotsUIStatus:GetColor();

	--red
	NoSpace = {}
    for i=-1, 5 do
      NoSpace[#NoSpace+1] = i + 1
    end

	for k = 1, #NoSpace do
		if CheckInventorySpaceSilently(NoSpace[k]) == true then
			red = 255;
			green = 0;
			blue = 0;
			alpha = 255;
		end
	end

	--orange
	SomeSpace = {}
    for i=6, 10 do
      SomeSpace[#SomeSpace+1] = i + 1
    end

	for k = 1, #SomeSpace do
		if CheckInventorySpaceSilently(SomeSpace[k]) == true then
			red = 128;
			green = 0;
			blue = 0;
			alpha = 255;
		end
	end

	--yellow
	DecentSpace = {}
    for i=11, 20 do
      DecentSpace[#DecentSpace+1] = i + 1
    end

	for k = 1, #DecentSpace do
		if CheckInventorySpaceSilently(DecentSpace[k]) == true then
			red = 255;
			green = 255;
			blue = 0;
			alpha = 255;
		end
	end

	--blue
	MediumSpace = {}
    for i=21, 30 do
      MediumSpace[#MediumSpace+1] = i + 1
    end

	for k = 1, #MediumSpace do
		if CheckInventorySpaceSilently(MediumSpace[k]) == true then
			red = 0;
			green = 255;
			blue = 255;
			alpha = 255;
		end
	end

	--green
	PlentyOfSpace = {}
    for i=31, 1000 do
      PlentyOfSpace[#PlentyOfSpace+1] = i + 1
    end

	for k = 1, #PlentyOfSpace do
		if CheckInventorySpaceSilently(PlentyOfSpace[k]) == true then
			red = 0;
			green = 255;
			blue = 0;
			alpha = 255;
		end
	end

	--getBagSpace
	slots = {}
    for i=0, 1000 do
      slots[i] = i + 1
    end

	for j = 0, #slots do
		if CheckInventorySpaceSilently(j) == true then
			bagSpace = j
		end
	end

	totalSlots = GetBagSize(BAG_BACKPACK)

	FreeSlotsUIStatus:SetColor(red, green, blue, alpha)


	FreeSlotsUIStatus:SetText(string.format(bagSpace .. "/" .. totalSlots))

	getBankSpaceToDisplay();

	getAlliancePointsToDisplay();

	getGoldToDisplay();


	return bagSpace,bagSpaceColor
end

function FreeSlots.OnMoveStop( self )
	FreeSlots.settings.wm.x = self:GetLeft();
	FreeSlots.settings.wm.y = self:GetTop();
	FreeSlots.settings.wm.width = self:GetWidth();
	FreeSlots.settings.wm.height = self:GetHeight();
end

local BufferTable = {}

function BufferReached(key, buffer)
	if key == nil then return end
	if BufferTable[key] == nil then BufferTable[key] = {} end
	BufferTable[key].buffer = buffer or 3
	BufferTable[key].now = GetFrameTimeSeconds()
	if BufferTable[key].last == nil then BufferTable[key].last = BufferTable[key].now end
	BufferTable[key].diff = BufferTable[key].now - BufferTable[key].last
	BufferTable[key].eval = BufferTable[key].diff >= BufferTable[key].buffer
	if BufferTable[key].eval then BufferTable[key].last = BufferTable[key].now end
	return BufferTable[key].eval
end

function OnUpdateHandler()
	if not BufferReached("myaddonupdatebuffer", 1) then
		return;
	end
	ShowFreeSlots()
end
